/// <reference types="codemirror" />
import { AfterViewInit, DoCheck, ElementRef, EventEmitter, KeyValueDiffers, NgZone, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as codemirror from 'codemirror';
export declare class CodemirrorComponent implements AfterViewInit, OnDestroy, ControlValueAccessor, DoCheck {
    private _differs;
    private _ngZone;
    className: string;
    name: string;
    autoFocus: boolean;
    /**
     * set options for codemirror
     * @link http://codemirror.net/doc/manual.html#config
     */
    options: {
        [key: string]: any;
    };
    preserveScrollPosition: boolean;
    cursorActivity: EventEmitter<codemirror.Editor>;
    focusChange: EventEmitter<boolean>;
    scroll: EventEmitter<codemirror.ScrollInfo>;
    ref: ElementRef;
    value: string;
    disabled: boolean;
    isFocused: boolean;
    codeMirror: CodeMirror.EditorFromTextArea;
    private _differ;
    private _options;
    constructor(_differs: KeyValueDiffers, _ngZone: NgZone);
    ngAfterViewInit(): void;
    ngDoCheck(): void;
    ngOnDestroy(): void;
    codemirrorValueChanged(doc: any, change: any): void;
    setOptionIfChanged(optionName: any, newValue: any): void;
    focusChanged(focused: boolean): void;
    scrollChanged(cm: any): void;
    cursorActive(cm: any): void;
    /** Implemented as part of ControlValueAccessor. */
    writeValue(value: string): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: string) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: () => void): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
    /** Implemented as part of ControlValueAccessor. */
    private onChange;
    /** Implemented as part of ControlValueAccessor. */
    private onTouched;
}
